int gate = 9;
int state = 0;

const int pingPin1 = 6;
const int echoPin1 = 5;
float distance;

int buttonPin1 = 3;

void setup() {
  Serial.begin(9600);
  pinMode(gate, OUTPUT);

  attachInterrupt(digitalPinToInterrupt(buttonPin1), DoNotDisturb, RISING);
}

void loop() {
Serial.println(state);
Serial.println(distance);


long duration1, inches1, distance;


   pinMode(pingPin1, OUTPUT);
   digitalWrite(pingPin1, LOW);
   delayMicroseconds(2);
   digitalWrite(pingPin1, HIGH);
   delayMicroseconds(10);
   digitalWrite(pingPin1, LOW);
   pinMode(echoPin1, INPUT);
   
   duration1 = pulseIn(echoPin1, HIGH);
   inches1 = microsecondsToInches(duration1);
   distance = microsecondsToCentimeters(duration1);
      
// GUIDE
//  analogWrite(gate, 50); //Level 0
//  delay(2000);
//
//  analogWrite(gate, 100); //Level 1
//  delay(2000);
//
//  analogWrite(gate, 450); //Level 2
//  delay(2000);
//  
//  analogWrite(gate, 1000); //Level 3
//  delay(2000);

if(state == 0 || state == 2 || state == 4 || state == 6){
  if(distance > 40){
    // nothing
    analogWrite(gate, 0); //nothing
  }
  if(distance < 40 && distance > 30){
    // level 0
    analogWrite(gate, 50); //Level 0
  }
  if(distance < 30 && distance > 20){
    // level 1
    analogWrite(gate, 100); //Level 1
  }
  if(distance < 20 && distance > 10){
    // level 2
    analogWrite(gate, 450); //Level 2
  }
  if(distance < 10){
    // level 3
    analogWrite(gate, 1000); //Level 3
  }
}

else {
  Serial.print("do not disturb");
  analogWrite(gate, 0); //nothing
}

}

void DoNotDisturb() {
  state++;
}

long microsecondsToInches(long microseconds) {
   return microseconds / 74 / 2;
}

long microsecondsToCentimeters(long microseconds) {
   return microseconds / 29 / 2;
}
